; File:     Screen3.asm
;---------------------------------------
   .586
    .model  flat, stdcall
    option  casemap :none
; 
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\Comctl32.inc
    
;----------------------------------------------
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\Comctl32.lib
    
; 
WinMain     proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc     proto   :DWORD,:DWORD,:DWORD,:DWORD 
WndProcA    proto   :DWORD,:DWORD,:DWORD,:DWORD

StatusProc  proto   :DWORD,:DWORD,:DWORD,:DWORD
EcraRes     proto   :DWORD,:DWORD,:DWORD,:DWORD
; 
CREATESTATUS  MACRO  hStatus, ID

       invoke CreateStatusWindow, WS_CHILD or WS_VISIBLE, NULL, hWnd, ID
       mov    hStatus, eax
       cmp     eax, 0
       je      @F
                                          
       ;---- [Size the Statusbar Control] ----
       mov     [_sbParts+0], 240
       mov     [_sbParts+4], 310       
       mov     [_sbParts+8], 1000       ;580 
       mov     [_sbParts+12], -1       ; The last part extends to the end
       ;
       invoke     SendMessage, hStatus, SB_SETPARTS, 4, addr _sbParts
       invoke     MoveWindow, hStatus, 0, 0, 0, 0, TRUE
@@:
ENDM 
; 
DIALOGBOX         MACRO  Name, Proc
    invoke  DialogBoxParam, _hInstance, addr Name, _hWnd, addr Proc, 0 
ENDM
; ##############################################################################################
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h


FIELDSRES   EQU   DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or DM_DISPLAYFLAGS or \
                  DM_DISPLAYFREQUENCY
;----------- Menus ---------------------
IDM_Menu1        equ 1001
IDM_Menu2        equ 1002
IDM_Menu3        equ 1003
;---------------------------------------
IDC_TITLE1          equ 4000
IDC_TITLE2          equ 4001

IDC_RBN1            equ 1001
IDC_RBN2            equ 1002
IDC_RBN3            equ 1003
IDC_RBN4            equ 1004
IDC_RBN5            equ 1005
IDC_RBN6            equ 1006
IDC_RBN7            equ 1007
IDC_RBN8            equ 1008
IDC_RBN9            equ 1009
IDC_RBN10           equ 1010

IDC_COMUTA          equ 2000
IDC_FECHA           equ 2001

DM_BITSPERPEL       equ 40000h
DM_PELSWIDTH        equ 80000h
DM_PELSHEIGHT       equ 100000h
DM_DISPLAYFLAGS     equ 200000h
DM_DISPLAYFREQUENCY equ 400000h

$ECRAWIDTH$         equ 1268              ; largura do exr
$ECRAHEIGHT$        equ 966               ; altura do ecr

;  Data Section 
.data
;---------------------------------------
_FontSSerif  db 'MS Sans Serif', 0
_FontComic   db 'Comic Sans MS', 0

_DlgMain     db 'EcraRes',0            ; Definido em rsrc.rc
_MenuName    db 'Menu',0               ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Change Resolution',0

; -------  Status Bar -------------------
_StatClass   db 'msctls_statusbar32',0
_sbParts     dd 4 dup (0)
_hWndStat    dd 0
_wStatus     dd 0

;
; rea de Cliente
; --------------- 
_ClientLeftX    dd 0         ; rectngulo left, top, right, bottom dwords
_ClientTopY     dd 0         ; 
_ClientDimX     dd 0         
_ClientDimY     dd 0
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
_hdc         dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>
_icce        INITCOMMONCONTROLSEX <?>          


_hWnd01      dd  ?
_hWnd02      dd  ?
_hWnd03      dd  ?
_hWnd04      dd  ?
_hWnd05      dd  ?
_hWnd06      dd  ?
_hWnd07      dd  ?
_hWnd08      dd  ?
_hWnd09      dd  ?
_hWnd10      dd  ?

_ScreenRes  DEVMODE <>
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax

    invoke    InitCommonControlsEx, ADDR _icce

    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT

; ##############################################################################################
align 16
WinMain     proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, eax          ; COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            ;invoke LoadIcon, hInst, offset _IconName     
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   0, 0, 1280, 990, NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            invoke  GetDC, _hWnd
            mov     _hdc, eax

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd
            
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; ----------------------------------------------------------------------------------------------
; Menu commands
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu1       ; Qualquer Coisa


                case    IDM_Menu2       ; Change Resolution

                    ; 
                    ; Open Dialog Box
                    ; 
                    DIALOGBOX _DlgMain, EcraRes

                case    IDM_Menu3       ; Fecha
                
                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           
                ;
                ;cmp     eax, WM_PAINT
                ;je      _WM_PAINT 
                ;
                cmp     eax, WM_CREATE
                je      _WM_CREATE
                
                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                ;
                cmp     eax, WM_DISPLAYCHANGE
                je      _WM_DISPLAYCHANGE
                
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE:      

                CREATESTATUS _hWndStat, 500h
                invoke  SetWindowLong, _hWndStat, GWL_WNDPROC, offset StatusProc
                mov     _wStatus, eax

                invoke     SetFocus, _hWndStat

                jmp       _ExitProcA
                
;------------------------------------------------------------------
;                            WM_DISPLAYCHANGE
; -----------------------------------------------------------------
_WM_DISPLAYCHANGE:  

                    invoke   DestroyWindow, _hWndStat

                    invoke   UpdateWindow, hWnd
                    jmp      _WM_CREATE
                    
                    ;jmp       _ExitProcA                
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp    
; ##############################################################################################
align 16
StatusProc      proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                SWITCH  uMsg
                CASE    WM_SETFOCUS

                    invoke     CreateCaret, _hWndStat, NULL, 1, 15 
                    invoke     SetCaretPos, 2, 3 
                    invoke     ShowCaret, _hWndStat

                CASE    WM_KILLFOCUS

                    call       DestroyCaret
                        
                DEFAULT
                
                    invoke  CallWindowProc, _wStatus, hWnd, uMsg, wParam, lParam   

                ENDSW
                ;
                xor     eax, eax
                ret
StatusProc      endp
; ##############################################################################################
; Dialog
;
EcraRes         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
    .if uMsg == WM_INITDIALOG
      invoke  CreateFont, 24, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, addr _FontSSerif
      invoke  SendDlgItemMessage, hWnd, IDC_TITLE1, WM_SETFONT, eax, 0  
;.........................................
      invoke  CreateFont, 16, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, addr _FontComic
      invoke  SendDlgItemMessage, hWnd, IDC_TITLE2, WM_SETFONT, eax, 0      
;..........................................

      invoke  GetDlgItem, hWnd, IDC_RBN1
      mov     _hWnd01, eax      
      invoke  GetDlgItem, hWnd, IDC_RBN2
      mov     _hWnd02, eax
      invoke  GetDlgItem, hWnd, IDC_RBN3
      mov     _hWnd03, eax
      invoke  GetDlgItem, hWnd, IDC_RBN4
      mov     _hWnd04, eax
      invoke  GetDlgItem, hWnd, IDC_RBN5
      mov     _hWnd05, eax
      invoke  GetDlgItem, hWnd, IDC_RBN6
      mov     _hWnd06, eax      
      invoke  GetDlgItem, hWnd, IDC_RBN7
      mov     _hWnd07, eax
      invoke  GetDlgItem, hWnd, IDC_RBN8
      mov     _hWnd08, eax      
      invoke  GetDlgItem, hWnd, IDC_RBN9
      mov     _hWnd09, eax
      invoke  GetDlgItem, hWnd, IDC_RBN10
      mov     _hWnd10, eax      

      invoke  SendMessage, _hWnd01, BM_SETCHECK, BST_CHECKED, 0
      invoke  SendMessage, _hWnd02, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd03, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd04, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd05, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd06, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd07, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd08, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd09, BM_SETCHECK, BST_UNCHECKED, 0
      invoke  SendMessage, _hWnd10, BM_SETCHECK, BST_UNCHECKED, 0      
      ret
    .elseif uMsg == WM_CLOSE        
      invoke  EndDialog, hWnd, 0    
      ret        
    .elseif uMsg == WM_COMMAND      
      mov     eax, wParam
      .if eax == IDC_COMUTA

        invoke    SendMessage, _hWnd01, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED
          call    SetResX        
          mov     _ScreenRes.dmPelsWidth, 800           ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 600          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 75     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd02, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED  
          call    SetResX              
          mov     _ScreenRes.dmPelsWidth, 960           ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 600          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 60     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd03, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED 
          call    SetResX               
          mov     _ScreenRes.dmPelsWidth, 1024          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 768          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 85     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd04, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED     
          call    SetResX           
          mov     _ScreenRes.dmPelsWidth, 1152          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 864          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 75     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd05, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED
          call    SetResX                
          mov     _ScreenRes.dmPelsWidth, 1280          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 720          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 75     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd06, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED
          call    SetResX                
          mov     _ScreenRes.dmPelsWidth, 1280          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 768          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 75     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd07, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED
          call    SetResX                
          mov     _ScreenRes.dmPelsWidth, 1280          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 800          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 60     ; Monitor Display Frequency
jmp     _next
        .endif

        invoke    SendMessage, _hWnd08, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED
          call    SetResX                
          mov     _ScreenRes.dmPelsWidth, 1280          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 960          ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 75     ; Monitor Display Frequency
jmp     _next
        .endif
        
        invoke    SendMessage, _hWnd09, BM_GETSTATE, 0, 0        
        .if eax == BST_CHECKED
          call    SetResX                
          mov     _ScreenRes.dmPelsWidth, 1280          ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 1024         ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 75     ; Monitor Display Frequency
jmp     _next
        .endif

          call    SetResX
          mov     _ScreenRes.dmPelsWidth,1600           ; X pixel width 
          mov     _ScreenRes.dmPelsHeight, 1200         ; Y pixel height 
          mov     _ScreenRes.dmDisplayFrequency, 60     ; Monitor Display Frequency

_next:  invoke  ChangeDisplaySettings, addr _ScreenRes, 0          
        
      .elseif eax == IDC_FECHA
        invoke  SendMessage, hWnd, WM_CLOSE, NULL, NULL
        ret
      .endif
    .endif
    xor     eax, eax
    ret
;--------------------------------------
EcraRes     endp
; 
SetResX     proc
            mov     _ScreenRes.dmFields, FIELDSRES
            mov     _ScreenRes.dmBitsPerPel, 32           ; Color bits
            mov     _ScreenRes.dmDisplayFlags, 0          ; Display mode noninterlaced
            mov     _ScreenRes.dmSize, sizeof _ScreenRes  ; Size of resolution structure
            ret
SetResX     endp
; 
    end     start

